package com.huiju.welcome.controller;

import com.huiju.welcome.common.base.ResponseBean;
import com.huiju.welcome.utils.AliOSSUtils;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.apache.http.HttpStatus;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;

/**
 * @author FXF
 * @date 2019-03-13
 */
@RestController
@RequestMapping("/")
public class ImgController {
	
	@Value("${huiju.files}")
	private String huijuFiles;

	private String subDir = "upload" + File.separator;
	
	@ApiOperation(value = "图片/视频上传以及获取url", notes = "图片/视频上传以及获取url")
	@PostMapping(value = "/uploadFile", consumes = "multipart/*", headers = "content-type=multipart/form-data")
	public ResponseBean uploadFile(@ApiParam(value = "uploadFile" ,required = true) MultipartFile uploadFile){
		ResponseBean responseBean = new ResponseBean();
		String suffix = uploadFile.getOriginalFilename().substring(uploadFile.getOriginalFilename().lastIndexOf(".") + 1);
		String fileName = System.currentTimeMillis() + "." + suffix;
		String path = huijuFiles;
		File tempFile = new File(path + subDir);
		if (!tempFile.exists()) {
			tempFile.mkdirs();
		}
		try {
			//下载文件
			FileOutputStream fos=new FileOutputStream(tempFile.getPath() + File.separator + fileName);
			FileInputStream fs=(FileInputStream) uploadFile.getInputStream();
			byte[] buffer=new byte[1024];
			int len=0;
			while((len=fs.read(buffer))!=-1){
				fos.write(buffer, 0, len);
			}
			fos.close();
			fs.close();
		}catch (Exception e){
			e.printStackTrace();
			responseBean.addError(e.getMessage());
			return responseBean;
		}
		responseBean.addSuccess(File.separator + subDir + fileName);
		return responseBean;
	}

	@PostMapping("/miniapp/upload")
	public ResponseBean uploadImage(@RequestParam("file") MultipartFile multipartFile) {
		String defaultUploadDir = "/";

		try {
			String img = AliOSSUtils.putObject(multipartFile, defaultUploadDir);
			return ResponseBean.success(img);
		} catch (IOException e) {
			return ResponseBean.error("上传图片失败: " + e.getMessage(), HttpStatus.SC_INTERNAL_SERVER_ERROR);
		}
	}
}
