package com.huiju.welcome.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.huiju.welcome.model.TaCustomer;
import com.huiju.welcome.model.TaDevice;
import com.huiju.welcome.model.TaMainUsherRecord;
import com.huiju.welcome.model.TaPerson;

import java.util.List;
import java.util.Map;

/**
 * <p>
 *  服务类
 * </p>
 *
 * @author jobob
 * @since 2019-03-12
 */
public interface ITaPersonService extends IService<TaPerson> {

    String updateAvatar(TaPerson taPerson,TaDevice...dev);

    Map<String,Object> detail(int id);
	
	Map<String, String> getDetailInfo(Integer personId, String deviceId);

    List<Map<String, String>> statsPerson();

    boolean updateSales(TaPerson taPerson);

    boolean mergePerson(Integer fromPerson, TaPerson toPerson);

    IPage<TaPerson> getRealPersonList(
            Page<TaPerson> page,
            Integer personId,
            Integer typeId,
            String name,
            String phone,
            String beginDate,
            String endDate
    );

    void logNew(String opertaor, TaPerson taPerson);

    void logEdit(String opertaor, TaPerson from, TaPerson to);

    TaPerson getByPhone(String phone);

    TaPerson newPersonByFront(TaCustomer taCustomer);

    TaPerson newPersonByUsher(TaMainUsherRecord taMainUsherRecord);
}
