package com.huiju.welcome.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huiju.welcome.model.TaDevice;
import com.huiju.welcome.model.TaPerson;
import com.huiju.welcome.service.ICameraService;
import com.huiju.welcome.service.ITaDeviceService;
import com.huiju.welcome.utils.Encrypt;
import com.huiju.welcome.utils.StatusUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.net.HttpURLConnection;
import java.net.URL;
import java.util.Arrays;
import java.util.List;

@Service
public class CameraServiceImpl implements ICameraService {
    @Autowired
    private ITaDeviceService taDeviceService;

    @Override
    public String dispatchPerson(TaPerson taPerson, TaDevice... devices) {
        List<TaDevice> taDeviceList = null;
        if (null == devices || devices.length == 0) {
            QueryWrapper<TaDevice> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("status",StatusUtils.Normal);
            taDeviceList = taDeviceService.list(queryWrapper);
        } else {
            taDeviceList = Arrays.asList(devices);
        }

        //分发人脸到各个相机
        for(TaDevice device: taDeviceList) {
            try {
                String api = device.getApi() + "/person/" + taPerson.getPersonId();
                byte[] data = ("image=" + Encrypt.urlEncode(taPerson.getAvatar())).getBytes("UTF-8");

                HttpURLConnection conn = (HttpURLConnection) new URL(api).openConnection();
                conn.setRequestMethod("POST");
                conn.setRequestProperty("Content-Type", "application/x-www-form-urlencoded");
                conn.setRequestProperty("Content-Length", String.valueOf(data.length));
                conn.setDoInput(true);
                conn.setDoOutput(true);
                conn.setUseCaches(false);
                conn.getOutputStream().write(data);

                if (conn.getResponseCode() == 200) {
                    System.out.println("========下发人脸完成=======");
                } else {
                    System.out.println("========下发人脸失败=======" + conn.getResponseMessage());
                }
            } catch (Exception e){
                e.printStackTrace();
                return "连接设备(" + device.getDeviceId() + ")人脸下发服务 失败: "+ e.getMessage();
            }
        }

        return "";
    }
}
